#include "stdafx.h"
#include "resource.h"
#include "Loader.h"
#include "Config.h"
 
using namespace Config;
 
class CShowSpecialFormShimModule : public CAtlDllModuleT< CShowSpecialFormShimModule >
{
public:
    DECLARE_NO_REGISTRY()
};
 
CShowSpecialFormShimModule _AtlModule;
 
extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
    hInstance;
    return _AtlModule.DllMain(dwReason, lpReserved);
}
 
STDAPI DllCanUnloadNow(void)
{
    return _AtlModule.DllCanUnloadNow();
}
 
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}
 
STDAPI DllInstall(BOOL mode, LPCWSTR token)
{
    HRESULT hr = S_OK;
 
    if (mode)
        IfFailGo(_AtlModule.DllRegisterServer(FALSE))
    else
        IfFailGo(_AtlModule.DllUnregisterServer(FALSE));
 
Error:
    return hr;
}
 
STDAPI DllRegisterServer(void)
{
    HRESULT hr = S_OK;
    CLoader *pLoader = NULL;
 
    pLoader = CLoader::TheInstance();
    IfNullGo(pLoader);
    IfFailGo(pLoader->RegisterADXProject(FrameworkVersion(), AssemblyName(), ClassName(), TRUE));
    IfFailGo(_AtlModule.DllRegisterServer(FALSE))
 
Error:
    return hr;
}
 
STDAPI DllUnregisterServer(void)
{
    HRESULT hr = S_OK;
    CLoader *pLoader = NULL;
 
    pLoader = CLoader::TheInstance();
    IfNullGo(pLoader);
    IfFailGo(pLoader->RegisterADXProject(FrameworkVersion(), AssemblyName(), ClassName(), FALSE));
    IfFailGo(_AtlModule.DllUnregisterServer(FALSE));
 
Error:
    return hr;
}
 

